module PlanetExpress
  class Repository
    attr_reader :data

    def initialize(data: )
      @data = data
    end

   def all
      data
    end

    def add(item)
      data.push(item)
    end

    def remove(item)
      data.delete(item)
    end

    def where(attribute_matchers = {})
      all.select do |entry|
        attribute_matchers.map do |attribute, value|
          entry.public_send(attribute.to_sym) == value
        end.all?
      end
    end
  end
end
